



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>20150913K-means聚类</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">20150913K-means聚类</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-24 01:37:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>1.聚类的思想：</h2>
<p>将一个有N个对象的数据集，构造成k(k&lt;=n)个划分，每个划分代表一个簇。使得每个簇包含一个对象，每个对象有且仅属于一个簇。<br />
对于给定的k，算法首先给出一个初始的划分方法，以后通过反复迭代的方法改变划分，<strong>使得每一次改进之后的划分方案都较前一次更好</strong>。</p>
<h2>2.K-means聚类</h2>
<h3>2.1K-means聚类的思想</h3>
<p>K-means算法使用广泛，有时候也作为其他聚类算法的基础。<br />
算法首先随机选择k个对象，每个对象初始地代表了一个簇的平均值和中心。对剩余的每个对象根据其与各个簇中心的距离，将它赋给最近的簇。然后重新计算每个簇的平均值。这个过程不断重复，直到准则函数（常常使用最小平方误差）收敛。<br />
其损失函数表达式为\(\sum_{i=1}^k \sum_{x_j \in S_j} \left(x_j - \mu_j \right)^2\)</p>
<h3>2.2K-means聚类的算法步骤</h3>
<pre class="prettyprint linenums"><code>输入：n个样本数据，分别为$x_1,x_2,\cdots,x_n$<br />
1. 随机选择k个聚类中心，$\mu_1,\mu_2,\cdots,\mu_k \in \mathbb{R}^{n}$<br />
2. 针对剩余的样本数据，将其类别标签设为距离其最近的聚类中心的标签。<br />
3. 将每个聚类中心的值更新为与该类所有样本的平均值。<br />
4. 重复以上步骤，直到聚类中心的变化小于规定的阈值即可。<br />
</code></pre>
<h3>2.3K-means聚类代码实现</h3>
<h4>2.3.1随机构造二维数据集</h4>
<pre class="prettyprint linenums"><code># -*- coding:utf-8 -*-<br />
import matplotlib.pyplot as plt<br />
from numpy import *<br />
import random<br />
flag = [&#039;b*&#039;,&#039;g+&#039;,&#039;rs&#039;,&#039;sb&#039;, &#039;db&#039;, &#039;&lt;b&#039;, &#039;pb&#039;]

def create():<br />
    num = 100<br />
    data = [[],[],[]]<br />
    dataCenter = [(2,3),(2.5,3),(2,2.5)]<br />
    for i in xrange(len(data)):<br />
        for j in xrange(num):<br />
            data[i].append((dataCenter[i][0]+random.uniform(-1,1)**2*random.uniform(-1,1), dataCenter[i][1]+random.uniform(-1,1)**2*random.uniform(-1,1)))<br />
    ##draw picture<br />
    global flag<br />
    for i in xrange(len(data)):<br />
        for j in data[i]:<br />
            plt.plot(j[0],j[1],flag[i])<br />
    plt.show()<br />
    return data[0]+data[1]+data[2]<br />
</code></pre>
<p><img referrerpolicy="no-referrer"src="http://7xlsu7.com1.z0.glb.clouddn.com/figure_1.png?imageView/2/w/600/q/100" /></p>
<h4>2.3.2K-means聚类python实现</h4>
<pre class="prettyprint linenums"><code># -*- coding:utf-8 -*-<br />
import matplotlib.pyplot as plt<br />
from numpy import *<br />
import random<br />
##计算两个点之间的距离，这里采用的是欧式距离，关于距离的选择，看场景。<br />
def distEclud(vecA, vecB):<br />
    return sqrt(sum(power(vecA-vecB,2)))

##初始化选择k个质心，这里选用的是从n个点中随机选出k个质心。<br />
def initCenter(data, k=2):<br />
    n = shape(data)[1]<br />
    centers = mat(zeros((k,n)))<br />
    for i in xrange(k):<br />
        index = int(random.uniform(0,len(data)))<br />
        centers[i] = data[index]<br />
    return centers

##计算上次和本次质心的距离偏差<br />
def deltaCenter(centers, centersNext):<br />
    return sqrt(sum(power(centers-centersNext,2)))

def KMeans(data,k=2):<br />
    centers = initCenter(data, k)<br />
    centersNext = mat(zeros((k,shape(data)[1])))<br />
    dataNum = shape(data)[0]<br />
    clusterRes = mat(zeros((dataNum,2)))<br />
    eps = 0.01<br />
    delta = inf<br />
    freq = 10<br />
    while eps &lt; delta and freq&gt;0:<br />
        freq -= 1<br />
        ##针对每个点划分类别<br />
        for i in xrange(dataNum):<br />
            mindist = inf<br />
            for j in xrange(k):<br />
                dist = distEclud(centers[j],data[i])<br />
                if dist&lt;mindist:<br />
                    mindist = dist<br />
                    minIndex = j<br />
            clusterRes[i] = [minIndex,mindist]<br />
        ##recalc the center of cluster<br />
        for j in xrange(k):<br />
            clusterData = data[nonzero(clusterRes[:,0].A==j)[0]]<br />
            centers[j] = mean(clusterData, axis=0)<br />
        ##计算上一次聚类中心和这一次的变动<br />
        delta = deltaCenter(centers,centersNext)<br />
    ##draw results<br />
    # global flag<br />
    # for i in xrange(k):<br />
    #     clusterData = data[nonzero(clusterRes[:,0].A==i)[0]]<br />
    #     for j in clusterData:<br />
    #         plt.plot(j[0,0],j[0,1],flag[i])<br />
    # plt.show()<br />
    return centers,clusterRes

if __name__ == &#039;__main__&#039;:<br />
    data = create()<br />
    KMeans(mat(data),3)<br />
</code></pre>
<p><img referrerpolicy="no-referrer"src="http://7xlsu7.com1.z0.glb.clouddn.com/figure_2.png?imageView/2/w/600/q/100" /><br />
3个聚类中心依次为：[1.95408899  2.44211387] [ 1.97371672  3.04483904][ 2.59031316  2.9787235 ]</p>
<h3>2.4K-means聚类缺点</h3>
<blockquote><p>初值敏感<br />
对噪声敏感<br />
不适于发现非凸面形状的簇或大小差别很大的簇<br />
无法保证收敛到全局最优<br />
有可能会出现某个聚类中心没有任何样本</p></blockquote>
<h2>3.二分K-means</h2>
<h3>3.1二分K-means算法步骤</h3>
<p>由于K-means算法有时候容易收敛到局部最小值，因此就提出了二分K-means。<br />
该算法是将所有点作为一个簇，然后将该簇一分为二，之后选择其中一个簇进行划分，选择哪一个簇进行划分取决于对其划分是否可以<strong>最大程度</strong>降低SSE(误差平方和)的值，直到得到指定的簇数目为止。<br />
聚类的SSE能够衡量聚类的性能，该值越小表示数据点越接近于它们的质心，聚类效果越好。所以</p>
<pre class="prettyprint linenums"><code>将所有数据看成一个簇，对该簇进行二分K-means<br />
当簇的数目小于k时<br />
    对每一个簇<br />
         进行K-means划分，其中K=2<br />
         计算划分后的总误差<br />
    选择总误差最小的那个簇进行划分<br />
</code></pre>
<h3>3.2二分K-means代码实现</h3>
<pre class="prettyprint linenums"><code># -*- coding:utf-8 -*-<br />
########################################<br />
# kmeans: k-means cluster<br />
# Author : xuke<br />
# Date   : 2015-09-14<br />
########################################<br />
import matplotlib.pyplot as plt<br />
from numpy import *<br />
import random<br />
flag = [&#039;b*&#039;,&#039;g+&#039;,&#039;rs&#039;,&#039;sb&#039;, &#039;db&#039;, &#039;&lt;b&#039;, &#039;pb&#039;]

def biKmeans(data,k=2):<br />
    dataNum = shape(data)[0]<br />
    clusterRes = mat(zeros((dataNum,2)))<br />
    center0 = mean(data,axis=0).tolist()[0]<br />
    centers = [center0]<br />
    ##计算一簇的簇心<br />
    for i in xrange(dataNum):<br />
        clusterRes[i,1] = distEclud(mat(center0), data[i])<br />
    while (len(centers) &lt; k):<br />
        minSSE = inf<br />
        ##遍历每个簇，划分每个簇，求得每个簇的SSE<br />
        for i in xrange(len(centers)):<br />
            dataNow = data[nonzero(clusterRes[:,0].A==i)[0],:]<br />
            centerTemp, clusterResTemp = KMeans(dataNow,2)<br />
            dataSSE = sum(clusterResTemp[:,1])<br />
            dataNoSSE = sum(clusterRes[nonzero(clusterRes[:,0].A!=i)[0],1])<br />
            if dataSSE + dataNoSSE &lt; minSSE:<br />
                bestCluster = i<br />
                bestCenter = centerTemp<br />
                bestClusterResTemp = clusterResTemp.copy()<br />
                minSSE = dataSSE + dataNoSSE<br />
        ##为选择出的最佳划分簇，打上类别，假设第2簇需要划分，且现在共有4簇，则第2簇打上2，4label。<br />
        bestClusterResTemp[nonzero(bestClusterResTemp[:,0].A == 1)[0],0] = len(centers)<br />
        bestClusterResTemp[nonzero(bestClusterResTemp[:,0].A == 0)[0],0] = bestCluster<br />
        ##将最佳质心append进centers这个list<br />
        centers[bestCluster] = bestCenter[0,:].tolist()[0]<br />
        centers.append(bestCenter[1,:].tolist()[0])<br />
        clusterRes[nonzero(clusterRes[:,0].A == bestCluster)[0],:] = bestClusterResTemp<br />
    ##draw results<br />
    global flag<br />
    for i in xrange(k):<br />
        clusterData = data[nonzero(clusterRes[:,0].A==i)[0]]<br />
        for j in clusterData:<br />
            plt.plot(j[0,0],j[0,1],flag[i])<br />
    plt.show()<br />
    return mat(centers), clusterRes

if __name__ == &#039;__main__&#039;:<br />
    data = create()<br />
    # print KMeans(mat(data), 4)[0]<br />
    print biKmeans(mat(data), 3)[0]<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1zl6z9.html">&lbrack;No00009F&rsqb;CMD在执行命令时的中断快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy0w4m8.html">css3使用box-sizing布局</a>
		</li>
						<li><a href="https://www.batexi.com/a/495y2veq.html">JSP 属性范围</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9po3vyq.html">转&colon; JSTL SQL标签库 使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jyy209.html">Java基础之集合框架&mdash;&mdash;使用HashMap地图（TryPhoneBook1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wwvoxq.html">js的with语句使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1om6d9.html">Python合并两个numpy矩阵</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvjnxyq.html">HACMP 学习笔记--转载自wangjialiang-csdn博客</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdrdlr8.html">iOS-MVVM--备用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjzeey9.html">c&plus;&plus;学习笔记&lpar;c&plus;&plus;中的引用&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pj7348.html">ASP&period;NET 导入excel 数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4y27x9.html">tensorflow源码阅读（c&plus;&plus;&rpar;（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw25w78.html">ELK学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwrxg78.html">Metasploit的射频收发器功能 &vert; Metasploit&rsquo;s RF Transceiver Capabilities</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw7lj09.html">opencv 基础数据结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdp7pe9.html">线程 day40</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rovnn9.html">判断某个字符串里面是否包含caoyang 这个字符串&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn5z24q.html">MySQL auto&lowbar;increment初始值设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx25prz8.html">mupdf编译snprintf冲突问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1p52x9.html">Linux下通过进程名查询占用的端口</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96oyn2v9.html">NSDate &amp;amp&semi; NSDateFormatter</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnw432q.html">linux系统快速查看进程pid的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zl70z9.html">20-语言入门-20-Financial Management</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm5wwz9.html">oracle 11g SQL Developer instead of isqlplus</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w2ogoq.html">真心崩溃了，oracle安装完成后居然没有tnsnames&period;ora和listener&period;ora文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1y7638.html">函数fil&lowbar;extend&lowbar;space&lowbar;to&lowbar;desired&lowbar;size</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okgxw59.html">fastdfs-client-java 文件上传</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1yr6x8.html">UVA 11090 Going in Cycle&excl;&excl;（二分答案&plus;判负环）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnywn08.html">I&period;MX6 开启 1000Mb&sol;s interface</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd7zl78.html">Java &lbrack;Leetcode 229&rsqb;Bulls and Cows</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
